import json

from aioredis import Redis
from fastapi import APIRouter, Depends, Request
import crud, schemas

from api import deps
from db.redisdb import get_redis_pool

router = APIRouter()


@router.post("/event")
async def read_event(
        request: Request,
        data_in: schemas.GetTable,
        rdb: Redis = Depends(get_redis_pool),
        current_user: schemas.UserDB = Depends(deps.get_current_user)
) -> schemas.Msg:
    """获取时间表结构"""
    data = await rdb.get(f'{data_in.game}_{data_in.name}')
    return schemas.Msg(code=0, msg='ok', data=json.loads(data))

