from typing import Optional

from schemas.base import DBBase

from pydantic import BaseModel, EmailStr, Field


class UserBase(BaseModel):
    email: Optional[EmailStr] = None
    is_superuser: bool = False
    name: Optional[str] = None


class User(UserBase):
    name: str


class UserLogin(BaseModel):
    username: str = ...
    password: str = ...


class UserCreate(UserBase):
    password: str
    name: str


# ****************************************************************************
# mongodb   模型


class UserDB(DBBase):
    email: EmailStr = None
    is_superuser: bool = False
    name: str


class UserDBRW(UserDB):
    hashed_password: str
